Package com.orchestranetworks.service.extensions

# Interface AdaptationTreeOptimizerIterator

public interface AdaptationTreeOptimizerIterator
Iterator for optimization.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Adaptation`
  `currentAdaptation()`
  Returns the current dataset, which will be optimized on the next call to `executeCurrent()`.
  `void`
  `executeAll()`
  Optimizes all remaining datasets in the iterator.
  `Adaptation`
  `executeCurrent()`
  Optimizes current dataset and sets the cursor to the next one.
  `boolean`
  `hasNext()`
  Returns `true` if there are still datasets to optimize, `false` otherwise.
  `boolean`
  `isForHandleDuplicates()`
  Returns `true` if the optimizer is handling duplicates in the dataset tree.
  `boolean`
  `isForRefactor()`
  Returns `true` if the optimizer is refactoring the dataset tree
  `Adaptation`
  `nextAdaptation()`
  Returns the next dataset, which will become the current one after the next call to `executeCurrent()`.

- ## Method Details

  - ### hasNext

    boolean hasNext()
    Returns `true` if there are still datasets to optimize, `false` otherwise.

  - ### currentAdaptation

    Adaptation currentAdaptation()
    Returns the current dataset, which will be optimized on the next call to `executeCurrent()`.

  - ### nextAdaptation

    Adaptation nextAdaptation()
    Returns the next dataset, which will become the current one after the next call to `executeCurrent()`.

  - ### executeAll

    void executeAll() throws OperationException
    Optimizes all remaining datasets in the iterator.
    Throws:
      `OperationException`

  - ### executeCurrent

    Adaptation executeCurrent() throws OperationException
    Optimizes current dataset and sets the cursor to the next one. Returns the optimized dataset, or `null` if there are no more to optimize.
    Throws:
      `OperationException`

  - ### isForRefactor

    boolean isForRefactor()
    Returns `true` if the optimizer is refactoring the dataset tree

  - ### isForHandleDuplicates

    boolean isForHandleDuplicates()
    Returns `true` if the optimizer is handling duplicates in the dataset tree.